/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TipoCambioCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.TipoCambioCiudad;
import com.rjconsultores.ventaboletos.entidad.TipoCambioCtrl;
import com.rjconsultores.ventaboletos.service.TipoCambioCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("tipoCambioCtrlService")
public class TipoCambioCtrlServiceImpl implements TipoCambioCtrlService {

    @Autowired
    private TipoCambioCtrlDAO tipoCambioCtrlDAO;

    public List<TipoCambioCtrl> obtenerTodos() {
        return tipoCambioCtrlDAO.obtenerTodos();
    }

    public TipoCambioCtrl obtenerID(Integer id) {
        return tipoCambioCtrlDAO.obtenerID(id);
    }

    @Transactional
    public TipoCambioCtrl suscribir(TipoCambioCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoCambioCtrlDAO.suscribir(entidad);
    }

    @Transactional
    public TipoCambioCtrl actualizacion(TipoCambioCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoCambioCtrlDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TipoCambioCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        for (TipoCambioCiudad tcc : entidad.getTipoCambioCiudadList()) {
            tcc.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            tcc.setFecmodif(Calendar.getInstance().getTime());
            tcc.setActivo(Boolean.FALSE);
        }

        tipoCambioCtrlDAO.actualizacion(entidad);
    }
}
